#include "B4RDefines.h"
namespace B4R
{
	// create an object of the class B4RLEDControl (instantiation)
	B4RLEDControl led;
	B4R::Timer* ledTimer;
	B4R::Pin* ledPin;

	void B4RLEDControl::Initialize(Byte PinNr, ULong BlinkInterval){
		::Serial.println("[DEBUG] Initialize start");
		//Assign the led to the private var used to get or set the led state
		ledPinNr 	= PinNr;
		::Serial.println(ledPinNr);
		::Serial.println(BlinkInterval);
		//Set the pin mode to output
		pinMode(PinNr, OUTPUT);
		//Turn the ledoff
		TurnOff();
		//Blink
		ledTimer->Initialize(Timer_Tick, BlinkInterval);
		ledTimer->setEnabled(false);
		::Serial.println("[DEBUG] Initialize done");
	}

	void B4RLEDControl::setBlink(bool State){
		ledTimer->setEnabled(State);
	}	

	bool B4RLEDControl::getBlink(){
		return ledTimer->getEnabled();
	}	
	
	void B4RLEDControl::TurnOff(){
		::Serial.println("TurnOff");
		setState(0);
	}	

	void B4RLEDControl::TurnOn(){
		::Serial.println("TurnOn");
		setState(1);
	}	

	void B4RLEDControl::setState(bool State){
		::Serial.println("setState");
		::Serial.println(State);
		::Serial.println(ledPinNr);
		digitalWrite(ledPinNr, State);
	}	

	bool B4RLEDControl::getState() {
		::Serial.println("getState");
		::Serial.println(digitalRead(ledPinNr));
		return digitalRead(ledPinNr);
	}

	B4RString* B4RLEDControl::getVersion(){
		PrintToMemory pm;
		B4RString* s = B4RString::PrintableToString(NULL);
		pm.print(version);
		StackMemory::buffer[StackMemory::cp++] = 0;
		return s;
	}

	void B4RLEDControl::Timer_Tick() {
		::Serial.println("Timer Tick");
		const UInt cp = B4R::StackMemory::cp;
		if (led.getState() == 1) {
			led.TurnOff();
		}
		else {
			led.TurnOn();
		}
		::Serial.println(led.getState());
		B4R::StackMemory::cp = cp;
	}

}