//Library for an LED 
//Documentation used:
//http://playground.arduino.cc
//Additional Libraries required:
//None
//Additional Classes required (included in the wrapped library folder):
//None
//20210716 rwbl
#pragma once
#include "B4RDefines.h"
//~Author: Robert W.B. Linn
//~Version: 0.11
namespace B4R
{
	//~Shortname: LEDControl
	class B4RLEDControl
	{
		private:
			String version = "20210716";
			Byte ledPinNr;
			static void Timer_Tick();

		public:
			/**
			*Initialize the LED
			*Example:<code>
			*LEDs connected to the Digital Pins D8=Red, D8=Yellow, D10=Green
			*Initialize(8,9,10)
			*</code>
			*/
			void Initialize(Byte PinNr, ULong BlinkInterval);
			
			/**
			*Turn the LED Off
			*/
			void TurnOff();
	
			/**
			*Turn the LED On
			*/
			void TurnOn();

			/**
			*Set the state for the LED: on = True or off = False
			*Example (Private led As LEDControl):<code>
			*led.State = False
			*</code>
			*/
			void setState(bool State);

			/**
			*Get the state for each of the LEDs Red-Yellow-Green as byte 0 (=off) or 1 (=on)
			*/
			bool getState();

			/**
			*Set Blink state
			*/
			void setBlink(bool State);
			
			/**
			*Get Blink state
			*/
			bool getBlink();

			/**
			*Get the library version.
			*Example (Private tl As TrafficLight):<code>
			*Log(tl.Version)
			*Output: 20170217
			*</code>
			*/
			B4RString* getVersion();

	};
}
